"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var camelcase = require("camelcase");
var utils_1 = require("./utils");
function getExternalModuleNames(fileList, projectPath, predefined) {
    if (predefined === void 0) { predefined = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var externalModuleNames, nodeModulePaths, potentialExternalModules, uniqueModuleNames, _i, uniqueModuleNames_1, moduleName;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    externalModuleNames = {};
                    return [4 /*yield*/, resolveNodeModulePaths(projectPath)];
                case 1:
                    nodeModulePaths = _a.sent();
                    potentialExternalModules = fileList.reduce(function (allModuleNames, aFile) {
                        return utils_1.uniqueArray(allModuleNames, aFile.getExternalModules());
                    }, []);
                    uniqueModuleNames = utils_1.uniqueArray(potentialExternalModules, Object.keys(predefined));
                    for (_i = 0, uniqueModuleNames_1 = uniqueModuleNames; _i < uniqueModuleNames_1.length; _i++) {
                        moduleName = uniqueModuleNames_1[_i];
                        if (isModuleAvailable(moduleName, nodeModulePaths)) {
                            externalModuleNames[moduleName] = predefined[moduleName] || convertModuleToCommonJs(moduleName);
                        }
                        else {
                            throw Error("Could not find module \"" + moduleName + "\". Did you install it?\nWe looked in:\n" + nodeModulePaths.join('\n')); // `;
                        }
                    }
                    return [2 /*return*/, externalModuleNames];
            }
        });
    });
}
exports.getExternalModuleNames = getExternalModuleNames;
function convertModuleToCommonJs(moduleName) {
    return moduleName
        .replace(/^@/, '')
        .split(/[\/\\]/)
        .map(function (part) { return camelcase(part); })
        .join('.')
        .replace(/angular/i, 'ng');
}
exports.convertModuleToCommonJs = convertModuleToCommonJs;
function nodeModuleExist(absPath) {
    return __awaiter(this, void 0, void 0, function () {
        var nodeModulePath;
        return __generator(this, function (_a) {
            nodeModulePath = path.resolve(absPath, 'node_modules');
            if (utils_1.isDirectory(nodeModulePath)) {
                return [2 /*return*/, nodeModulePath];
            }
            return [2 /*return*/, false];
        });
    });
}
exports.nodeModuleExist = nodeModuleExist;
function resolveNodeModulePaths(searchInPath) {
    return __awaiter(this, void 0, void 0, function () {
        var nodeModulePaths, currentPathNodeModule, parentDir, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    nodeModulePaths = [];
                    return [4 /*yield*/, nodeModuleExist(searchInPath)];
                case 1:
                    currentPathNodeModule = _c.sent();
                    if (currentPathNodeModule !== false) {
                        nodeModulePaths = utils_1.uniqueArray(nodeModulePaths, [currentPathNodeModule]);
                    }
                    parentDir = path.dirname(searchInPath);
                    if (!(parentDir !== '/')) return [3 /*break*/, 3];
                    _a = utils_1.uniqueArray;
                    _b = [nodeModulePaths];
                    return [4 /*yield*/, resolveNodeModulePaths(parentDir)];
                case 2:
                    nodeModulePaths = _a.apply(void 0, _b.concat([_c.sent()]));
                    _c.label = 3;
                case 3: return [2 /*return*/, nodeModulePaths];
            }
        });
    });
}
exports.resolveNodeModulePaths = resolveNodeModulePaths;
function getModuleFromImportStatements(importStatement) {
    return importStatement;
}
exports.getModuleFromImportStatements = getModuleFromImportStatements;
function getModuleNamesFromFile(aFile) {
    return aFile
        .getImporteeNames()
        .map(function (moduleName) { return getModuleFromImportStatements(moduleName); });
}
exports.getModuleNamesFromFile = getModuleNamesFromFile;
function getModuleNamesFromFileList(fileList) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, fileList.reduce(function (allModuleNames, aFile) {
                    return utils_1.uniqueArray(allModuleNames, getModuleNamesFromFile(aFile));
                }, [])];
        });
    });
}
exports.getModuleNamesFromFileList = getModuleNamesFromFileList;
function isModuleAvailable(moduleName, nodeModulePaths) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, nodeModulePaths.some(function (aPath) { return utils_1.isDirectory(path.resolve(aPath, moduleName)); })];
        });
    });
}
exports.isModuleAvailable = isModuleAvailable;
//# sourceMappingURL=external-modules.js.map